var VimeoLogger = {
	error: function(data) {
		this.call('error', data);
	},
	
	log: function(id, data) {
		if(!data) data = {};
		$extend(data, {
			id: id
		});
		this.call('log', data);
	},
	
	bug: function(txt) {
		this.call('bug', {
			bug_desc: txt
		});
	},
	
	call: function(type, data) {
		if(!data) data = {};
		
		$extend(data, {
			user_id: vimeo.user_id,
			token: vimeo.token,
			log_type: type,
			api_key: vimeo.key,
			os: air.Capabilities.os + ',' + Utility.getApplicationVersion()
		});
		
		new AJAX('http://' + VIMEO_URL + '/air/duplo/log', {
			post: data,
			hide_response: true,
			silence_errors: true
		});
	}
};

function submit_bug() {
	VimeoLogger.bug($('bug_desc').value);
	$('bug_desc').value = '';
	bug_lightbox.hide();
	show_message('Thank you! We will be investigating your problem.');
}