var lightboxes = [];		//List of all lightbox window popups in the app

var Lightbox = new Class({
	bg: false,
	content: false,
	is_visible: false,
	
	Implements: Events,
	
	options: {
		width: 300
	},
	
	initialize: function(content_id, options) {
		this.bg = new Element('div', { 
			'style': 'z-index:900000; position:absolute; top: 0px; left: 0px; background: #000; opacity: 0.5; filter: alpha(opacity=50)'
		});
		
		$(document.body).adopt(this.bg);
		//this.bg.addEvent('click', this.hide.bind(this));
		
		this.content = $(content_id).moveToBottom();
		this.content.setStyle('position', 'absolute');
		this.content.setX(0);
		this.content.setY(0);
		
		this.hide();
		
		nativeWindow.addEventListener(air.NativeWindowBoundsEvent.RESIZE, this.redraw.bind(this));
		lightboxes.push(this);
	},
	
	redraw: function() {
		if(this.is_visible) {
			var w = $(document.body).getWidth();
			var h = $(document.body).getHeight();
			
			this.content.setX(w / 2 - this.content.getWidth() / 2);
			this.content.setY(h / 2 - this.content.getHeight() / 2);
			
			this.bg.setWidth(w);
			this.bg.setHeight(h);
		}
	},
	
	show: function(ignoreClose) {
		//Hide other lightboxes
		lightboxes.each(function(item) {
			if( item.is_visible ) this.content.store('cur_lightbox', item);
			item.hide();
		}.bind(this));
		
		if( !ignoreClose && this.content.retrieve('cur_lightbox'))
		{
			this.addEvent('windowClose', function() {
				this.content.retrieve('cur_lightbox').show(true);
			}.bind(this));
		}
		
		this.is_visible = true;
		this.content.show();
		this.bg.show();
		
		this.redraw();
	},
	
	hide: function() {
		this.is_visible = false;
		this.bg.hide();
		this.content.hide();
	},
	
	close: function() {
		this.hide();
		this.fireEvent('windowClose');
	}
});