Function.implement({
	
});

Element.implement({
	toggle: function() {
		if (this.getStyle('display') != 'none') this.setStyle('display','none');
		else this.setStyle('display','');
	},	
	lift: function() { this.toggle(); },
	toggleVis: function() {
		if (this.getStyle('visibility') != 'hidden') this.setStyle('visibility','hidden');
		else this.setStyle('visibility','visible');
	},	
	hide: function(visibility) {
		if(visibility) this.setStyle('visibility', 'hidden');
		else this.setStyle('display', 'none');
	},	
	show: function(visibility) {
		if(visibility) this.setStyle('visibility', 'visible');
		else this.setStyle('display', '');
	},
	isShowing: function() {
		return this.getStyle('display') != 'none';
	},
	moveToBottom: function() {
		var w = this.clone();
		this.destroy();
		$(document.body).adopt(w);
		return w;
	},
	disable: function(txt)	{
		if( this.toString().indexOf('HTMLInput') > 0 ) {
			this.addClass('disabled');
			if(txt) this.value = txt;
			this.disabled = true;
			return;
		}
		
		$$('#' + this.id + ' select, #' + this.id + ' input').setProperty('disabled', true);
		
		if( $(this.id + '_disable') ) {
			$(this.id + '_disable').destroy();
		}
		
		this.setStyle('position', 'relative');
		if( !$(this.id + '_disable') ) {
			var coords = this.getSize();
			this.adopt(
				new Element('div', {
					'id': this.id + '_disable',
					'styles': {
						'background-color': !txt ? '#fff' : '#' + txt,
						'width': coords.x,
						'height': coords.y,
						'top': '0',
						'left': '0',
						'position': 'absolute',
						'opacity': 0.7,
						'z-index': 100101
					}
				})
			);
		}
	},
	
	enable: function(txt) {
		
		if( this.toString().indexOf('HTMLInput') > 0 ) {
			this.disabled = false;
			this.removeClass('disabled');
			if(txt) this.value = txt;
			return;
		}
		
		$$('#' + this.id + ' select, #' + this.id + ' input').setProperty('disabled', false);
		
		this.setStyle('position', '');
		if( $(this.id + '_disable') ) {
			$(this.id + '_disable').destroy();
		}
	},
	
	setWidth: function(num, max) {
		var att = max ? 'max-width' : 'width';
		this.setStyle(att, num.toString() + 'px');
	},
	
	setHeight: function(num, max) {
		var att = max ? 'max-height' : 'height';
		this.setStyle(att, num.toString() + 'px');
	},
	
	getWidth: function() {
		return this.isShowing() ? this.getSize().x : 0;
	},
	
	getHeight: function() {
		return this.isShowing() ? this.getSize().y : 0;
	},
	
	getX: function() {
		return this.getPosition().x;
	},
	
	setX: function(num) {
		this.setStyle('left', Math.round(num.toInt()) + 'px');
	},
	
	getY: function() {
		return this.getPosition().y;
	},
	
	setY: function(num) {
		this.setStyle('top', Math.round(num.toInt()) + 'px');
	},
	
	getBottomY: function() {
		return this.getHeight() + this.getPosition().y;
	}
});

Array.implement({
	removeAt: function(index) {
		this.splice(index, 1);
		return this;
	}
});
 
var Sortables2 = new Class({
	options: {
		container: false,
		onComplete: false,
	},
	
	list: false,
	children: false,
	clone: false,
	is_dragging: false,
	is_mouse_down: false,
	cur_child_index: false,
	prev_sort: false, // prev arrangement so we dont oncomplete things we dont have to
	
	prev_mouse_pos: 0,
	start_mouse_pos: 0,
	allow_mouse_move: false, // toggle to allow the dragging to start and continue
	
	locked: false,
	
	initialize: function(list, options) {
		this.setOptions(options);
		
		this.list = $(list);
		this.children = [];
		
		if( this.list ) {
			var c = this.list.getChildren();
			
			for(var i = 0; i < c.length; i++) {
				this.addItem(c[i]);
			}
		}
	},
	
	addItem: function(el) {
		this.children.push($(el));
		this.addListeners(this.children[this.children.length - 1]);
		
		this.prev_sort = this.getList();
	},
	
	removeItem: function(el) {
		for(var i = 0; i < this.children.length; i++) {
			if(el.id == this.children[i].id) {
				this.removeListeners(this.children[i]);
				this.children.erase(this.children[i]);
				break;
			}
		}
	},
	
	addListeners: function(el) {
		el.addEvent('mousedown', this.mouseDown.bind(this));
	},
	
	removeListeners: function(el) {
		el.removeEvents('mousedown');
	},
	
	resetListeners: function() {
		for(var i = 0; i < this.children.length; i++) {
			this.removeListeners(this.children[i]);
			this.addListeners(this.children[i]);
		}
	},
	
	validateChild: function(child) {
		if(!child) return false;
		for(var i = 0; i < this.children.length; i++) {
			if( child.id == this.children[i].id ) return true;
		}
		return false;
	},
	
	getChildIndexByEl: function(child) {
		for(var i = 0; i < this.children.length; i++) {
			if( child.id == this.children[i].id ) return i;
		}
		return false;
	},
	
	lock: function() {
		this.locked = true;
	},
	
	unlock: function() {
		this.locked = false;
	},
	
	mouseMove: function(e) {
		if( this.is_mouse_down && !this.locked ) {
			if( Math.abs(e.client.y - this.start_mouse_pos.y) <= 5 && Math.abs(e.client.x - this.start_mouse_pos.x) <= 5 && !this.allow_mouse_move ) {
				return false;
			} 
			
			$('container').addClass('moving');
			this.allow_mouse_move = true;
			
			if( !this.is_dragging ) {
				this.clone = this.children[this.cur_child_index].clone();
				this.clone.setStyle('position', 'absolute');
				this.clone.setStyle('opacity', '.5');
				this.clone.setStyle('cursor', 'move');
				$(document.body).adopt(this.clone);
				this.children[this.cur_child_index].setStyle('visibility', 'hidden');
			}
			
			this.is_dragging = true;
			this.clone.setStyle('top', (e.client.y - this.clone.getHeight() / 2)+ 'px');
			
			if(this.options.container) {
				// top limit
				if(this.clone.getY() < $(this.options.container).getY()) 
					this.clone.setStyle('top', $(this.options.container).getY() + 'px');
					
				// bottom limit
				if(this.clone.getBottomY() > $(this.options.container).getBottomY()) 
					this.clone.setStyle('top', ($(this.options.container).getBottomY() - this.clone.getHeight()) + 'px');
				
				this.clone.setStyle('left', $(this.options.container).getX() + 'px');
				this.clone.setWidth(this.children[this.cur_child_index].getWidth() - 
									this.children[this.cur_child_index].getStyle('paddingLeft').toInt() -
									this.children[this.cur_child_index].getStyle('paddingRight').toInt());
			}
			
			var dir = e.client.y - this.prev_mouse_pos > 0 ? -1 : 1;
			var new_pos = this.cur_child_index;
			
			if( dir == -1 ) { // down
				for(var i = 0; i < this.children.length; i++) {
					if( e.client.y > this.children[i].getY() ) {
						new_pos = i;
					}
				}
			}
			else {
				for(var i = this.children.length - 1; i >= 0; i--) {
					if( e.client.y < this.children[i].getBottomY() ) {
						new_pos = i;
					}
				}
			}
			
			// move the child element now
			if(new_pos != this.cur_child_index) {
				var old_pos = this.cur_child_index;
				this.cur_child_index = new_pos;
				
				// move the element
				var tmp = this.children[old_pos];
				this.children[old_pos].inject(this.children[new_pos], dir == -1 ? 'after' : 'before');
				
				// swap the references
				this.children[old_pos] = this.children[new_pos];
				this.children[new_pos] = tmp;
			}
			
			this.prev_mouse_pos = e.client.y;
		}
	},
	
	mouseDown: function(e) {
		if(this.locked) return false;
	
		this.prev_mouse_pos = e.client.y;
		this.start_mouse_pos = e.client;
		this.allow_mouse_move = false;
		
		// Traverse upward to find the right element
		var cur_el = $(e.target);
		var is_child = this.validateChild(cur_el);
		while( !is_child && cur_el ) {
			cur_el = cur_el.getParent();
			is_child = this.validateChild(cur_el);
		}
		
		var i = this.getChildIndexByEl(cur_el);
		this.cur_child_index = i;

		this.is_dragging = false;
		this.is_mouse_down = true;
		
		$(document.body).addEvent('mousemove', this.mouseMove.bind(this));
		$(document.body).addEvent('mouseup', this.mouseUp.bind(this));
	},
	
	mouseUp: function(e) {
		if(this.locked) return false;

		$('container').removeClass('moving');
		$(document.body).removeEvents('mousemove');
		$(document.body).removeEvents('mouseup');
		
		if( this.clone ) this.clone.destroy();
		for(var i = 0; i < this.children.length; i++) {
			this.children[i].setStyle('visibility', 'visible');
		}
		
		this.clone = false;
		this.cur_child_index = false;
		this.is_dragging = false;
		this.is_mouse_down = false;
		
		if(this.prev_sort.toString() != this.getList().toString() && this.options.onComplete) 
			this.options.onComplete(this.getList());
		
		this.prev_sort = this.getList();
	},
	
	getList: function() {
		var ids = [];
		for(var i = 0; i < this.children.length; i++) {
			ids.push(this.children[i].id);
		}
		return ids;
	}
});
Sortables2.implement(new Options);