var SwfUtility = new window.runtime.Utilities;

var UniqueId = (new Date()).getTime();

var Utility = {
	
	goToURL: function(url) {
		air.navigateToURL(new air.URLRequest(url)); 
	},
	
	formatBytes: function(bytes, integerize) {
		bytes = Math.abs(bytes);	
	
	   	if (bytes < 1024 * 1024)
			return this.numberFormat(bytes / 1024, 2, '.', ',', integerize) + ' KB';
	 	        
		if (bytes < 1024 * 1024 * 1024)
	 		return this.numberFormat(bytes / (1024 * 1024), 2, '.', ',', integerize) + ' MB';
	 	
		return this.numberFormat(bytes / (1024 * 1024 * 1024), 2, '.', ',', integerize) + ' GB';
	},
	
	pad: function(str, length, pad_str) {
		length = length.toInt() - str.toString().length;
		padding = '';
		for( var i = 0; i < length; i++) {
			padding += pad_str.toString();
		}
		return padding + str.toString();
	},
	
	numberFormat: function( number, decimals, dec_point, thousands_sep, integerize ) {
		// Formats a number with grouped thousands  
		// 
		// version: 902.1517
		// discuss at: http://phpjs.org/functions/number_format
		// +   original by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
		// +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
		// +     bugfix by: Michael White (http://getsprink.com)
		// +     bugfix by: Benjamin Lupton
		// +     bugfix by: Allan Jensen (http://www.winternet.no)
		// +    revised by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
		// +     bugfix by: Howard Yeend
		// +    revised by: Luke Smith (http://lucassmith.name)
		// +     bugfix by: Diogo Resende
		// +     bugfix by: Rival
		// %        note 1: For 1000.55 result with precision 1 in FF/Opera is 1,000.5, but in IE is 1,000.6
		// *     example 1: number_format(1234.56);
		// *     returns 1: '1,235'
		// *     example 2: number_format(1234.56, 2, ',', ' ');
		// *     returns 2: '1 234,56'
		// *     example 3: number_format(1234.5678, 2, '.', '');
		// *     returns 3: '1234.57'
		// *     example 4: number_format(67, 2, ',', '.');
		// *     returns 4: '67,00'
		// *     example 5: number_format(1000);
		// *     returns 5: '1,000'
		// *     example 6: number_format(67.311, 2);
		// *     returns 6: '67.31'
		var n = number, prec = decimals;
		n = !isFinite(+n) ? 0 : +n;
		prec = !isFinite(+prec) ? 0 : Math.abs(prec);
		var sep = (typeof thousands_sep == "undefined") ? ',' : thousands_sep;
		var dec = (typeof dec_point == "undefined") ? '.' : dec_point;
		var s = (prec > 0) ? n.toFixed(prec) : Math.round(n).toFixed(prec); //fix for IE parseFloat(0.55).toFixed(0) = 0;
		var abs = Math.abs(n).toFixed(prec);
		var _, i;
		
		if (abs >= 1000) {
			_ = abs.split(/\D/);
			i = _[0].length % 3 || 3;
			_[0] = s.slice(0,i + (n < 0)) +
			_[0].slice(i).replace(/(\d{3})/g, sep+'$1');
			s = _.join(dec);
		} else {
			s = s.replace('.', dec);
		}
		
		//Removes the decimal if it equals 00
		if( integerize ) s = s.split('.00').join('');
		
		return s;
	},
	
	toFixed: function(val, x) {
	   return Math.round(val * Math.pow(10, x)) / Math.pow(10, x);
	},
	
	md5: function(bytes) {
		return SwfUtility.md5_hashBytes(bytes);
	},
	
	getUniqueId: function(index) {
		return /*UniqueId + '_' + */index;
	},
	
	getAPISecret: function(bytes) {
		return SwfUtility.getAPISecret();
	},
	
	getDevAPISecret: function(bytes) {
		return SwfUtility.getDevAPISecret();
	},
	
	verifyJSONResponse: function(json) {
		if (json) {
			return json.stat == 'ok';
		}
		return false;
	},
	
	formatSeconds: function(secs) {
		if(!secs || secs == Infinity || secs < 0) secs = 0;
		
		var s = secs % 60;
		var m = Math.floor(secs / 60) % 60;
		var h = Math.floor(secs / 60 / 60);
		
		return Utility.pad(h, 2, 0) + ':' + Utility.pad(m, 2, 0) + ':' + Utility.pad(s, 2, 0);
	},
	
	// TODO: Add a check where if the value goes up from the previous, it has to go up by more than 20% for it to change the display
	getSimpleTime: function(secs) {
		if(!secs || secs == Infinity || secs < 0) secs = 0;
		
		var s = secs % 60 ;
		var m = secs / 60 % 60;
		var h = secs / 60 / 60;
		var d = h / 24;
		
		var text = '';
		
		// debug('getSimpleTime ' + d + ' days ' + h + ' hours ' + m + ' minutes ' + s + ' seconds ');
		
		//Days
		if( d >= 1 )
		{
			if( d == 1 ) text = 'Around a day';
			else text = 'Around ' + Math.round(d) + ' days';
		}
		else if( h >= 1 )
		{
			if( h >= 1 && h <= 1.25 ) text = 'About an hour';
			else if( h > 3 ) text = 'About ' + Math.floor(h) + ' hours';
			else
			{
				if( h - Math.floor(h) > .5 ) text = 'About ' + Math.floor(h) + ' and a half hours';
				else text = 'About ' + Math.floor(h) + ' hours';
			};
		}
		else if( m >= .75 )
		{
			//Round to the nearest 10 minutes
			if( m > 30 ) text = 'About ' + ( Math.round(m/10) * 10 ) + ' minutes';
			
			//Round to the nearest 5 minutes
			else if( m < 30 && m > 10 ) text = 'About ' + ( Math.round(m/5) * 5 ) + ' minutes';
			
			//Between 45 seconds and a minute left
			else if( m > .75 && Math.round(m) < 2 ) text = 'About a minute';
			
			//Less than 10 seconds but greater than a minute left
			else text = 'About ' + Math.round(m) + ' minutes';
		}
		else
		{
			if( s > 10 ) text = 'About ' + ( Math.round(s/15) * 15 ) + ' seconds';
			else if( Math.round(s) > 1 ) text = 'About ' + ( Math.round(s/5) * 5 ) + ' seconds';
			else text = 'Less than a second';
		}
		
		return text;
	},
	
	getLocalStore: function(id) {
		var str = air.EncryptedLocalStore.getItem(id);
		return  str ? str.toString() : false;
		// var storedValue = air.EncryptedLocalStore.getItem(id);
		// return storedValue.readUTFBytes(storedValue.length);
	},
	
	setLocalStore: function(id, val) {
		var bytes = new air.ByteArray();
        bytes.writeUTFBytes(val.toString());
        air.EncryptedLocalStore.setItem(id, bytes);
	},
	
	getApplicationVersion: function() {
		// This will get the version of the currently installed application
		var appXML = air.NativeApplication.nativeApplication.applicationDescriptor;
		var xmlObject = new DOMParser().parseFromString(appXML, "text/xml");
		return xmlObject.getElementsByTagName('version')[0].firstChild.nodeValue; //parseFloat(xmlObject.getElementsByTagName('version')[0].firstChild.nodeValue);
	},
	
	/**
	 * Compares two version numbers. Returns 1 if the first is larger (newer),
	 * -1 if it is smaller (older), and 0 if they're the same.
	 **/
	compareVersions: function(version1, version2) 
	{
		/**
		 * Equalize version numbering systems.
		 * The old system was, for Eg. 0.940 while the new system is 0.9.4. This
		 * strips them apart and makes them both of the system 0.9.4
		 **/
		version1 = version1.toString().split('.').join('').split('').join('.');
		version2 = version2.toString().split('.').join('').split('').join('.');
		
		if( version1.length > version2.length ) 
			version2 = this.normalizeVersionFormatting( version1, version2 );
		else if( version2.length > version1.length )
			version1 = this.normalizeVersionFormatting( version2, version1 );
		
		// debug('compareVersions ' + version1 + ' vs ' + version2);
		
		return this.doCompare(version1.toString().split('.'), version2.toString().split('.'), 0)
	},
	
	doCompare: function( arr1, arr2, curIndex )
	{
		// debug('doCompare ' + arr1[curIndex] + ' vs ' + arr2[curIndex] + ' index: ' + curIndex);
		
		if( arr1[curIndex] > arr2[curIndex] ) 
		{
			return 1;
		}
		else if( arr2[curIndex] > arr1[curIndex] )
		{
			return -1;
		}
		else
		{
			//Last sub version number
			if( curIndex >= arr1.length ) return 0;
			else return this.doCompare(arr1, arr2, curIndex+1);
		}
	},
	
	/**
	 * Normalizes the version formatting. Eg, if the two versions are 9.0.1 and 10.0,
	 * it turns 10.0 into 10.0.0
	 **/
	normalizeVersionFormatting: function(ver1, ver2)
	{
		while(ver2.length < ver1.length) {
			ver2 += '.0';
		}
		
		return ver2;
	}
};